//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// Pawcio: BC Download
#pragma once

#include "ThrottledSocket.h"
class CPartFile;
class CClientReqSocket;

class DownloadBandwidthThrottler :
    public CWinThread 
{
public:
    DownloadBandwidthThrottler(void);
    ~DownloadBandwidthThrottler(void);

    bool QueueForReceivingPacket(ThrottledControlSocket* socket);
    void RemoveFromAllQueues(ThrottledControlSocket* socket);

    void EndThread();

    void Pause(bool paused);

	void AddToStandardList(CClientReqSocket* socket);
	void AddToStandardListNoLock(CClientReqSocket* socket);
    void RemoveFromStandardList(CClientReqSocket* socket);
	void DecreaseToReceive(const int& bytes) {toReceive -= bytes;}
	void SetTimeDown(uint8 time) {timeDown = time;}
	void ReSortDownloadSlots(CUpDownClient* client);
private:
    static UINT RunProc(LPVOID pParam);
    UINT RunInternal();

    void RemoveFromAllQueues(ThrottledControlSocket* socket, bool lock);
    void RemoveFromStandardListNoLock(CClientReqSocket* socket);

    CTypedPtrList<CPtrList, ThrottledControlSocket*> m_ControlQueue_list; // a queue for all the sockets that want to have Receive() called on them.

    CCriticalSection receiveLocker;

    CEvent* threadEndedEvent;
    CEvent* pauseEvent;

    bool doRun;

	CTypedPtrList<CPtrList, CClientReqSocket*> downloadinglist;
	POSITION receivingPos;
	int     toReceive;
	uint8	timeDown;
};