
// PPgBandwidthControl.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgBandwidthControl.h"
#include "scheduler.h"
#include "otherfunctions.h"
#include "uploadqueue.h"
#include "UploadBandwidthThrottler.h"
#include ".\ppgbandwidthcontrol.h"
#include "Preferences.h"
// PPgBandwidthControl dialog

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


IMPLEMENT_DYNAMIC(CPPgBandwidthControl, CPropertyPage)
CPPgBandwidthControl::CPPgBandwidthControl()
	: CPropertyPage(CPPgBandwidthControl::IDD)
{
}

CPPgBandwidthControl::~CPPgBandwidthControl()
{
}

void CPPgBandwidthControl::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);

	//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	DDX_Control(pDX, IDC_USSMIN, m_minUpload);
	DDX_Control(pDX, IDC_USSMAX, m_maxUpload);
	DDX_Control(pDX, IDC_DSSMIN, m_minDownload);
	DDX_Control(pDX, IDC_DSSMAX, m_maxDownload);
	// Maella end
}


BEGIN_MESSAGE_MAP(CPPgBandwidthControl, CPropertyPage)
	ON_EN_CHANGE(IDC_USS_SLIDER, OnSettingsChange)
	ON_EN_CHANGE(IDC_USSMAX, OnSettingsChange)
	ON_EN_CHANGE(IDC_USSMIN, OnSettingsChange)
	ON_EN_CHANGE(IDC_DSS_SLIDER, OnSettingsChange)
	ON_EN_CHANGE(IDC_DSSMAX, OnSettingsChange)
	ON_EN_CHANGE(IDC_DSSMIN, OnSettingsChange)
	ON_BN_CLICKED(IDC_UP_AUTO, OnSettingsChangeBox)
	ON_BN_CLICKED(IDC_UP_MAXPING_TEXT, OnSettingsChangeBox)
	ON_BN_CLICKED(IDC_DOWN_AUTO, OnSettingsChangeBox)
	ON_BN_CLICKED(IDC_DOWN_MAXPING_TEXT, OnSettingsChangeBox)
	ON_BN_CLICKED(IDC_MANAGE_CONNECTIONS, OnSettingsChangeBox)
	ON_BN_CLICKED(IDC_URL_AUTO, OnSettingsChange)
	ON_BN_CLICKED(IDC_USS, OnSettingsChangeBox)
	ON_BN_CLICKED(IDC_DSS, OnSettingsChangeBox)
	ON_BN_CLICKED(IDC_ZZ_RATIO, OnSettingsChange)
	ON_BN_CLICKED(IDC_UP_MINIMIZE, OnSettingsChangeBox)
	ON_BN_CLICKED(IDC_UP_CUMULATE, OnSettingsChange)
	ON_BN_CLICKED(IDC_BADWOLFSUPLOAD, OnSettingsChangeBox)
	ON_BN_CLICKED(IDC_PROTOCOL_OVERHEAD, OnSettingsChange)
	ON_BN_CLICKED(IDC_CONNECTIONS_OVERHEAD, OnSettingsChange)
	ON_BN_CLICKED(IDC_TCP_ACK, OnSettingsChangeBox)
	ON_BN_CLICKED(IDC_BCADVANCED, OnAdvancedClicked)
	ON_BN_CLICKED(IDC_UDP_PING, OnSettingsChangeBox)
	ON_BN_CLICKED(IDC_NO_TTL, OnSettingsChangeBox)
	ON_EN_CHANGE(IDC_URL_PING, OnSettingsChange)
	ON_EN_CHANGE(IDC_UP_MAXPING_INPUT, OnSettingsChange)
	ON_EN_CHANGE(IDC_DOWN_MAXPING_INPUT, OnSettingsChange)
	ON_EN_CHANGE(IDC_EGOINGDOWN, OnSettingsChange)
	ON_EN_CHANGE(IDC_EGOINGUP, OnSettingsChange)
	ON_WM_HSCROLL()
END_MESSAGE_MAP()

void CPPgBandwidthControl::LoadSettings(void)
{
	//Added by Pawcio
	char buffer[200];
	CString strBuffer;
	MEMSET(&buffer,0,200);

	CheckDlgButton(IDC_USS,thePrefs.USSEnabled);
	CheckDlgButton(IDC_UP_AUTO,thePrefs.autoMaxUp);
	CheckDlgButton(IDC_UP_MAXPING_TEXT, thePrefs.manualUpMaxPing);
	((CSliderCtrl*)GetDlgItem(IDC_USS_SLIDER))->SetRange(1,24,true);
	((CSliderCtrl*)GetDlgItem(IDC_USS_SLIDER))->SetPos(thePrefs.USSSliderPos);

    //Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	strBuffer.Format(_T("%.1f"), thePrefs.minBCUpload);
	GetDlgItem(IDC_USSMIN)->SetWindowText(strBuffer);
	
	strBuffer.Format(_T("%.1f"), thePrefs.maxBCUpload);
	GetDlgItem(IDC_USSMAX)->SetWindowText(strBuffer);
	//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-

	CheckDlgButton(IDC_DSS,thePrefs.DSSEnabled);
	CheckDlgButton(IDC_DOWN_AUTO,thePrefs.autoMaxDown);
	CheckDlgButton(IDC_DOWN_MAXPING_TEXT, thePrefs.manualDownMaxPing);
	((CSliderCtrl*)GetDlgItem(IDC_DSS_SLIDER))->SetRange(1,24,true);
	((CSliderCtrl*)GetDlgItem(IDC_DSS_SLIDER))->SetPos(thePrefs.DSSSliderPos);

    //Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	strBuffer.Format(_T("%.1f"), thePrefs.minBCDownload);
	GetDlgItem(IDC_DSSMIN)->SetWindowText(strBuffer);

	strBuffer.Format(_T("%.1f"), thePrefs.maxBCDownload);
	GetDlgItem(IDC_DSSMAX)->SetWindowText(strBuffer);
	//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-

	strBuffer.Format(_T("%d"), thePrefs.m_iDynUpGoingDownDivider);
	GetDlgItem(IDC_EGOINGDOWN)->SetWindowText(strBuffer);

	strBuffer.Format(_T("%d"), thePrefs.m_iDynUpGoingUpDivider);
	GetDlgItem(IDC_EGOINGUP)->SetWindowText(strBuffer);

	CheckDlgButton(IDC_UDP_PING, thePrefs.UDPing);
	CheckDlgButton(IDC_NO_TTL, thePrefs.noTTL);
	CheckDlgButton(IDC_URL_AUTO,thePrefs.autoHostToPing);
	CheckDlgButton(IDC_ZZ_RATIO,thePrefs.ZZRatio);
	CheckDlgButton(IDC_UP_MINIMIZE,thePrefs.minimizeOpenedSlots);
	CheckDlgButton(IDC_UP_CUMULATE,thePrefs.cumulateBandwidth);
	CheckDlgButton(IDC_BADWOLFSUPLOAD,thePrefs.BadwolfsUpload);
	CheckDlgButton(IDC_PROTOCOL_OVERHEAD,thePrefs.includeOverhead);
	CheckDlgButton(IDC_CONNECTIONS_OVERHEAD,thePrefs.connectionsOverhead);
	CheckDlgButton(IDC_TCP_ACK,thePrefs.includeTCPAck);
	CheckDlgButton(IDC_MANAGE_CONNECTIONS, thePrefs.manageConnections);

	strBuffer = thePrefs.url_ping;
	strBuffer.Trim();
	GetDlgItem(IDC_URL_PING)->SetWindowText(strBuffer);

	strBuffer.Format(_T("%d"), thePrefs.base_ping_up);
	GetDlgItem(IDC_UP_MAXPING_INPUT)->SetWindowText(strBuffer);

	strBuffer.Format(_T("%d"), thePrefs.base_ping_down);
	GetDlgItem(IDC_DOWN_MAXPING_INPUT)->SetWindowText(strBuffer);
	OnSettingsChangeBox();
	SetAdvanced(false);
}
void CPPgBandwidthControl::Localize(void)
{	
	if(m_hWnd)
	{
		GetDlgItem(IDC_USS)->SetWindowText( GetResString(IDS_USS) );
		GetDlgItem(IDC_USSMAX_TEXT)->SetWindowText( GetResString(IDS_USSMAX) );
		GetDlgItem(IDC_USSMIN_TEXT)->SetWindowText( GetResString(IDS_USSMIN) );
		GetDlgItem(IDC_UP_AUTO)->SetWindowText( GetResString(IDS_UP_AUTO));
		GetDlgItem(IDC_UP_MAXPING_TEXT)->SetWindowText( GetResString(IDS_UP_MAXPING_TEXT));
		GetDlgItem(IDC_URL_PING_TEXT)->SetWindowText( GetResString(IDS_URL_PING) );
		GetDlgItem(IDC_UDP_PING)->SetWindowText( GetResString(IDS_UDP_PING));
		GetDlgItem(IDC_NO_TTL)->SetWindowText( GetResString(IDS_NO_TTL));
		GetDlgItem(IDC_MANAGE_CONNECTIONS)->SetWindowText( GetResString(IDS_MANAGE_CONNECTIONS));
		GetDlgItem(IDC_ZZ_RATIO)->SetWindowText( GetResString(IDS_ZZ_RATIO) );
		GetDlgItem(IDC_UP_MINIMIZE)->SetWindowText( GetResString(IDS_UP_MINIMIZE) );
		GetDlgItem(IDC_UP_CUMULATE)->SetWindowText( GetResString(IDS_UP_CUMULATE) );
		GetDlgItem(IDC_BADWOLFSUPLOAD)->SetWindowText(GetResString(IDS_BADWOLFSUPLOAD));
		GetDlgItem(IDC_PROTOCOL_OVERHEAD)->SetWindowText( GetResString(IDS_PROTOCOL_OVERHEAD) );
		GetDlgItem(IDC_CONNECTIONS_OVERHEAD)->SetWindowText( GetResString(IDS_CONNECTIONS_OVERHEAD) );
		GetDlgItem(IDC_TCP_ACK)->SetWindowText( GetResString(IDS_TCP_ACK) );
		GetDlgItem(IDC_LOWER_TEXT)->SetWindowText( GetResString(IDS_LOWER_TEXT));
		GetDlgItem(IDC_HIGHER_TEXT)->SetWindowText( GetResString(IDS_HIGHER_TEXT));
		GetDlgItem(IDC_MINDOWN_STATIC)->SetWindowText( GetResString(IDS_MINDOWN));
		GetDlgItem(IDC_MAXDOWN_STATIC)->SetWindowText( GetResString(IDS_MAXDOWN));
		GetDlgItem(IDC_PINGING_STATIC)->SetWindowText( GetResString(IDS_PINGING));
		GetDlgItem(IDC_BCADVANCED)->SetWindowText( GetResString(IDS_ADVANCED) + (thePrefs.advancedBC ? _T("   ^") : _T("   v")));
		GetDlgItem(IDC_GOINGDOWN_S)->SetWindowText( GetResString(IDS_DYNUP_GOINGDOWNDIVIDER));
		GetDlgItem(IDC_GOINGUP_S)->SetWindowText( GetResString(IDS_DYNUP_GOINGUPDIVIDER));
		GetDlgItem(IDC_MS_TEXT)->SetWindowText( GetResString(IDS_MS_TEXT));
		GetDlgItem(IDC_MS_TEXT2)->SetWindowText( GetResString(IDS_MS_TEXT));

		GetDlgItem(IDC_DSS)->SetWindowText( GetResString(IDS_DSS) );
		GetDlgItem(IDC_DSSMAX_TEXT)->SetWindowText( GetResString(IDS_DSSMAX) );
		GetDlgItem(IDC_DSSMIN_TEXT)->SetWindowText( GetResString(IDS_DSSMIN) );
		GetDlgItem(IDC_DOWN_AUTO)->SetWindowText( GetResString(IDS_UP_AUTO));
		GetDlgItem(IDC_DOWN_MAXPING_TEXT)->SetWindowText( GetResString(IDS_UP_MAXPING_TEXT));
		GetDlgItem(IDC_LOWER_TEXT2)->SetWindowText( GetResString(IDS_LOWER_TEXT2));
		GetDlgItem(IDC_HIGHER_TEXT2)->SetWindowText( GetResString(IDS_HIGHER_TEXT2));
		GetDlgItem(IDC_STATUS_FRAME)->SetWindowText( GetResString(IDS_STATUS_BC));
	}
}

// PPgBandwidthControl message handlers

BOOL CPPgBandwidthControl::OnApply()
{
	CString buffer;
	thePrefs.USSEnabled = (uint8)IsDlgButtonChecked(IDC_USS);
	thePrefs.autoMaxUp = IsDlgButtonChecked(IDC_UP_AUTO);
	thePrefs.manualUpMaxPing = IsDlgButtonChecked(IDC_UP_MAXPING_TEXT);

	//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	if(GetDlgItem(IDC_USSMIN)->GetWindowTextLength())
	{
		GetDlgItem(IDC_USSMIN)->GetWindowText(buffer);
		float upload = _tstof(buffer);
		thePrefs.minBCUpload=(upload < 1.0f ? 1.0f : upload);
	}
	if(GetDlgItem(IDC_USSMAX)->GetWindowTextLength())
	{
		GetDlgItem(IDC_USSMAX)->GetWindowText(buffer);
		float upload = _tstof(buffer);
		thePrefs.maxBCUpload = ((upload >= 1.0f || upload == 0.0f)? upload : 1.0f);
	}
    //Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	if(thePrefs.maxBCUpload < thePrefs.minBCUpload && thePrefs.maxBCUpload != 0.0f)
		thePrefs.maxBCUpload = thePrefs.minBCUpload;

	thePrefs.DSSEnabled = (uint8)IsDlgButtonChecked(IDC_DSS);
	thePrefs.autoMaxDown = IsDlgButtonChecked(IDC_DOWN_AUTO);
	thePrefs.manualDownMaxPing = IsDlgButtonChecked(IDC_DOWN_MAXPING_TEXT);

    //Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	if(GetDlgItem(IDC_DSSMIN)->GetWindowTextLength())
	{
		GetDlgItem(IDC_DSSMIN)->GetWindowText(buffer);
		float download = _tstof(buffer);
		thePrefs.minBCDownload=(download < 1.0f ? 1.0f : download);
	}
	if(GetDlgItem(IDC_DSSMAX)->GetWindowTextLength())
	{
		GetDlgItem(IDC_DSSMAX)->GetWindowText(buffer);
		float download = _tstof(buffer);
		thePrefs.maxBCDownload=((download >= 1.0f || download == 0.0f) ? download : 1.0f);
	}
    //Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	if(thePrefs.maxBCDownload < thePrefs.minBCDownload && thePrefs.maxBCDownload != 0.0f)
		thePrefs.maxBCDownload = thePrefs.minBCDownload;

	CString strBuffer;
	if(GetDlgItem(IDC_EGOINGDOWN)->GetWindowTextLength())
	{
		GetDlgItem(IDC_EGOINGDOWN)->GetWindowText(buffer);
		int going = _tstoi(buffer);
		if (going > 10)
			thePrefs.m_iDynUpGoingDownDivider = going;
		else {
			strBuffer.Format(_T("%d"), thePrefs.m_iDynUpGoingDownDivider);
			GetDlgItem(IDC_EGOINGDOWN)->SetWindowText(strBuffer);
		}
	}

	if(GetDlgItem(IDC_EGOINGUP)->GetWindowTextLength())
	{
		GetDlgItem(IDC_EGOINGUP)->GetWindowText(buffer);
		int going = _tstoi(buffer);
		if (going > 10)
			thePrefs.m_iDynUpGoingUpDivider = going;
		else {
			strBuffer.Format(_T("%d"), thePrefs.m_iDynUpGoingUpDivider);
			GetDlgItem(IDC_EGOINGUP)->SetWindowText(strBuffer);
		}
	}

	thePrefs.UDPing = IsDlgButtonChecked(IDC_UDP_PING);
	thePrefs.noTTL = IsDlgButtonChecked(IDC_NO_TTL);
	thePrefs.autoHostToPing = IsDlgButtonChecked(IDC_URL_AUTO);
	thePrefs.manageConnections = IsDlgButtonChecked(IDC_MANAGE_CONNECTIONS);
	thePrefs.ZZRatio = IsDlgButtonChecked(IDC_ZZ_RATIO);
	if (thePrefs.minimizeOpenedSlots != (bool)IsDlgButtonChecked(IDC_UP_MINIMIZE) ||
		thePrefs.cumulateBandwidth != (bool)IsDlgButtonChecked(IDC_UP_CUMULATE))
		theApp.uploadBandwidthThrottler->ResetBC();
	thePrefs.minimizeOpenedSlots = IsDlgButtonChecked(IDC_UP_MINIMIZE);
	thePrefs.cumulateBandwidth = IsDlgButtonChecked(IDC_UP_CUMULATE);
	thePrefs.BadwolfsUpload = IsDlgButtonChecked(IDC_BADWOLFSUPLOAD);
	thePrefs.includeOverhead = IsDlgButtonChecked(IDC_PROTOCOL_OVERHEAD);
	thePrefs.connectionsOverhead = IsDlgButtonChecked(IDC_CONNECTIONS_OVERHEAD);
	thePrefs.includeTCPAck = IsDlgButtonChecked(IDC_TCP_ACK);

	if (GetDlgItem(IDC_URL_PING)->GetWindowTextLength()) {
		CString strBuffer;
		GetDlgItem(IDC_URL_PING)->GetWindowText(strBuffer);
		strBuffer.Trim();
		if (strBuffer != CString(thePrefs.url_ping)){
			_tcscpy(thePrefs.url_ping, strBuffer);
			if (!theApp.BC->SetIP(strBuffer)) {
				MessageBox(_T("URL/IP in \"Pawcio Tweaks\" tab is not valid! Please, enter new valid one or leave blank."),_T("Error"),MB_ICONERROR|MB_OK);
			}
		}
	}
	else if (thePrefs.url_ping[0]){
		thePrefs.url_ping[0]=0;
		theApp.BC->SetIP(_T(""));
	}	

	if (GetDlgItem(IDC_UP_MAXPING_INPUT)->GetWindowTextLength()) {
		GetDlgItem(IDC_UP_MAXPING_INPUT)->GetWindowText(buffer) ;
		if (_tstoi(buffer) < 5) {
			thePrefs.base_ping_up = 5 ;
			buffer.Format(_T("%d"), thePrefs.base_ping_up);
			GetDlgItem(IDC_UP_MAXPING_INPUT)->SetWindowText(buffer) ;
		} else if (_tstoi(buffer) > 2500) {
			thePrefs.base_ping_up = 2500 ;
			buffer.Format(_T("%d"), thePrefs.base_ping_up);
			GetDlgItem(IDC_UP_MAXPING_INPUT)->SetWindowText(buffer);
		} else {
			thePrefs.base_ping_up = (_tstoi(buffer) / 5) * 5; // convert to 5 multiple
			buffer.Format(_T("%d"), thePrefs.base_ping_up);
			GetDlgItem(IDC_UP_MAXPING_INPUT)->SetWindowText(buffer);
		}
	}

	if (GetDlgItem(IDC_DOWN_MAXPING_INPUT)->GetWindowTextLength()) {
		GetDlgItem(IDC_DOWN_MAXPING_INPUT)->GetWindowText(buffer) ;
		if (_tstoi(buffer) < 5) {
			thePrefs.base_ping_down = 5 ;
			buffer.Format(_T("%d"), thePrefs.base_ping_down);
			GetDlgItem(IDC_DOWN_MAXPING_INPUT)->SetWindowText(buffer) ;
		} else if (_tstoi(buffer) > 3500) {
			thePrefs.base_ping_down = 3500 ;
			buffer.Format(_T("%d"), thePrefs.base_ping_down);
			GetDlgItem(IDC_DOWN_MAXPING_INPUT)->SetWindowText(buffer);
		} else {
			thePrefs.base_ping_down = (_tstoi(buffer) / 5) * 5; // convert to 10 multiple
			buffer.Format(_T("%d"), thePrefs.base_ping_down);
			GetDlgItem(IDC_DOWN_MAXPING_INPUT)->SetWindowText(buffer);
		}
	}
	theApp.scheduler->SaveOriginals(); // Pawcio: SS Scheduler
	UpdateBCStatus(false);
	return CPropertyPage::OnApply();
}

BOOL CPPgBandwidthControl::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	InitWindowStyles(this);

	LoadSettings();
	Localize();
	UpdateBCStatus();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
void CPPgBandwidthControl::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	SetModified(TRUE);
	
	CSliderCtrl* slider =(CSliderCtrl*)pScrollBar;
	CString temp;
	if (pScrollBar==GetDlgItem(IDC_USS_SLIDER)) {
		thePrefs.USSSliderPos = slider->GetPos();
	}
	else if (pScrollBar==GetDlgItem(IDC_DSS_SLIDER)) {
		thePrefs.DSSSliderPos = slider->GetPos();
	}
}

afx_msg void CPPgBandwidthControl::SetBoxes(){
	if( IsDlgButtonChecked(IDC_USS)){
		GetDlgItem(IDC_USSMIN)->EnableWindow(TRUE);
		GetDlgItem(IDC_USSMAX)->EnableWindow(TRUE);
		GetDlgItem(IDC_UP_AUTO)->EnableWindow(TRUE);
		GetDlgItem(IDC_USS_SLIDER)->EnableWindow(TRUE);
		GetDlgItem(IDC_UP_MAXPING_TEXT)->EnableWindow(TRUE);
		GetDlgItem(IDC_UP_MAXPING_INPUT)->EnableWindow(TRUE);
	}
	else{
		GetDlgItem(IDC_USSMIN)->EnableWindow(FALSE);
		GetDlgItem(IDC_USSMAX)->EnableWindow(FALSE);
		GetDlgItem(IDC_UP_AUTO)->EnableWindow(FALSE);
		GetDlgItem(IDC_USS_SLIDER)->EnableWindow(FALSE);
		GetDlgItem(IDC_UP_MAXPING_TEXT)->EnableWindow(FALSE);
		GetDlgItem(IDC_UP_MAXPING_INPUT)->EnableWindow(FALSE);
	}
	if ( IsDlgButtonChecked(IDC_USS) || IsDlgButtonChecked(IDC_DSS)){
		GetDlgItem(IDC_UDP_PING)->EnableWindow(TRUE);
		GetDlgItem(IDC_NO_TTL)->EnableWindow(TRUE);
		GetDlgItem(IDC_URL_AUTO)->EnableWindow(TRUE);
		GetDlgItem(IDC_URL_PING)->EnableWindow(TRUE);
	}
	else{
		GetDlgItem(IDC_UDP_PING)->EnableWindow(FALSE);
		GetDlgItem(IDC_NO_TTL)->EnableWindow(FALSE);
		GetDlgItem(IDC_URL_AUTO)->EnableWindow(FALSE);
		GetDlgItem(IDC_URL_PING)->EnableWindow(FALSE);
	}
	if (IsDlgButtonChecked(IDC_UP_AUTO) && IsDlgButtonChecked(IDC_USS))
		GetDlgItem(IDC_USSMAX)->EnableWindow(FALSE);
	if (IsDlgButtonChecked(IDC_UP_MAXPING_TEXT)&& IsDlgButtonChecked(IDC_USS)){
		GetDlgItem(IDC_USS_SLIDER)->EnableWindow(FALSE);
	}
	else if (IsDlgButtonChecked(IDC_USS)){
		GetDlgItem(IDC_UP_MAXPING_INPUT)->EnableWindow(FALSE);
	}
	if (IsDlgButtonChecked(IDC_TCP_ACK) || IsDlgButtonChecked(IDC_CONNECTIONS_OVERHEAD) && !IsDlgButtonChecked(IDC_MANAGE_CONNECTIONS))
		GetDlgItem(IDC_ZZ_RATIO)->EnableWindow(FALSE);
	else
		GetDlgItem(IDC_ZZ_RATIO)->EnableWindow(TRUE);

	if( IsDlgButtonChecked(IDC_DSS)){
		GetDlgItem(IDC_DSSMIN)->EnableWindow(TRUE);
		GetDlgItem(IDC_DSSMAX)->EnableWindow(TRUE);
		GetDlgItem(IDC_DOWN_AUTO)->EnableWindow(TRUE);
		GetDlgItem(IDC_DSS_SLIDER)->EnableWindow(TRUE);
		GetDlgItem(IDC_DOWN_MAXPING_TEXT)->EnableWindow(TRUE);
		GetDlgItem(IDC_DOWN_MAXPING_INPUT)->EnableWindow(TRUE);
	}
	else{
		GetDlgItem(IDC_DSSMIN)->EnableWindow(FALSE);
		GetDlgItem(IDC_DSSMAX)->EnableWindow(FALSE);
		GetDlgItem(IDC_DOWN_AUTO)->EnableWindow(FALSE);
		GetDlgItem(IDC_DSS_SLIDER)->EnableWindow(FALSE);
		GetDlgItem(IDC_DOWN_MAXPING_TEXT)->EnableWindow(FALSE);
		GetDlgItem(IDC_DOWN_MAXPING_INPUT)->EnableWindow(FALSE);
	}
	if (IsDlgButtonChecked(IDC_DOWN_AUTO) && IsDlgButtonChecked(IDC_DSS))
		GetDlgItem(IDC_DSSMAX)->EnableWindow(FALSE);
	if (IsDlgButtonChecked(IDC_DOWN_MAXPING_TEXT)&& IsDlgButtonChecked(IDC_DSS)){
		GetDlgItem(IDC_DSS_SLIDER)->EnableWindow(FALSE);
	}
	else if (IsDlgButtonChecked(IDC_DSS)){
		GetDlgItem(IDC_DOWN_MAXPING_INPUT)->EnableWindow(FALSE);
	}

	/*if (IsDlgButtonChecked(IDC_NO_TTL)){
		GetDlgItem(IDC_UDP_PING)->EnableWindow(FALSE);
	}
	else if (IsDlgButtonChecked(IDC_DSS) || IsDlgButtonChecked(IDC_USS)){
		GetDlgItem(IDC_UDP_PING)->EnableWindow(TRUE);
	}

	if (IsDlgButtonChecked(IDC_UDP_PING)){
		GetDlgItem(IDC_URL_AUTO)->EnableWindow(FALSE);
	}
	else if (IsDlgButtonChecked(IDC_DSS) || IsDlgButtonChecked(IDC_USS)){
		GetDlgItem(IDC_URL_AUTO)->EnableWindow(TRUE);
	}*/

	if (IsDlgButtonChecked(IDC_BADWOLFSUPLOAD)){
		GetDlgItem(IDC_UP_CUMULATE)->EnableWindow(FALSE);
		GetDlgItem(IDC_UP_MINIMIZE)->EnableWindow(FALSE);
		GetDlgItem(IDC_MANAGE_CONNECTIONS)->EnableWindow(FALSE);
	}
	else{
		GetDlgItem(IDC_UP_CUMULATE)->EnableWindow(TRUE);
		GetDlgItem(IDC_UP_MINIMIZE)->EnableWindow(TRUE);
		GetDlgItem(IDC_MANAGE_CONNECTIONS)->EnableWindow(TRUE);
	}
}

afx_msg void CPPgBandwidthControl::SetAdvanced(bool clicked){
	if (clicked) thePrefs.advancedBC = !thePrefs.advancedBC;
	GetDlgItem(IDC_BCADVANCED)->SetWindowText( GetResString(IDS_ADVANCED) + (thePrefs.advancedBC ? _T("   ^") : _T("   v")));
	if (!IsDlgButtonChecked(IDC_UP_MAXPING_TEXT) && !thePrefs.advancedBC){
		GetDlgItem(IDC_UP_MAXPING_TEXT)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_UP_MAXPING_INPUT)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_MS_TEXT)->ShowWindow(SW_HIDE);
	}
	else{
		GetDlgItem(IDC_UP_MAXPING_TEXT)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_UP_MAXPING_INPUT)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_MS_TEXT)->ShowWindow(SW_SHOW);
	}
	if (!IsDlgButtonChecked(IDC_DOWN_MAXPING_TEXT) && !thePrefs.advancedBC){
		GetDlgItem(IDC_DOWN_MAXPING_TEXT)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_DOWN_MAXPING_INPUT)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_MS_TEXT2)->ShowWindow(SW_HIDE);
	}
	else{
		GetDlgItem(IDC_DOWN_MAXPING_TEXT)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_DOWN_MAXPING_INPUT)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_MS_TEXT2)->ShowWindow(SW_SHOW);
	}
	GetDlgItem(IDC_URL_PING_TEXT)->ShowWindow(thePrefs.advancedBC ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_URL_PING)->ShowWindow(thePrefs.advancedBC ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_UDP_PING)->ShowWindow(thePrefs.advancedBC ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_NO_TTL)->ShowWindow(thePrefs.advancedBC ? SW_SHOW : SW_HIDE); // [ionix]
	GetDlgItem(IDC_URL_AUTO)->ShowWindow(thePrefs.advancedBC ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_PROTOCOL_OVERHEAD)->ShowWindow(thePrefs.advancedBC ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_MANAGE_CONNECTIONS)->ShowWindow(thePrefs.advancedBC ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_CONNECTIONS_OVERHEAD)->ShowWindow(thePrefs.advancedBC ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_TCP_ACK)->ShowWindow(thePrefs.advancedBC ? SW_SHOW : SW_HIDE);

	GetDlgItem(IDC_EGOINGDOWN)->ShowWindow(thePrefs.advancedBC ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_EGOINGUP)->ShowWindow(thePrefs.advancedBC ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_GOINGDOWN_S)->ShowWindow(thePrefs.advancedBC ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_GOINGUP_S)->ShowWindow(thePrefs.advancedBC ? SW_SHOW : SW_HIDE);
}

void CPPgBandwidthControl::UpdateBCStatus(bool withSSStats){
	if(m_hWnd){
		if (thePrefs.IsUSSEnabled() && theApp.BC->IsPingPreparing() && withSSStats)
			GetDlgItem(IDC_USS_STATUS)->SetWindowText(GetResString(IDS_SS_PREPARING));
		else if (thePrefs.IsUSSEnabled() && theApp.BC->IsPingWorking())
			GetDlgItem(IDC_USS_STATUS)->SetWindowText(GetResString(IDS_SS_SUCCESFULL));
		else if (thePrefs.IsUSSEnabled() && withSSStats)
			GetDlgItem(IDC_USS_STATUS)->SetWindowText(GetResString(IDS_SS_FAILED));
		else if (withSSStats || !thePrefs.IsUSSEnabled())
			GetDlgItem(IDC_USS_STATUS)->SetWindowText(GetResString(IDS_SS_DISABLED));

		if (thePrefs.IsDSSEnabled() && theApp.BC->IsPingPreparing() && withSSStats)
			GetDlgItem(IDC_DSS_STATUS)->SetWindowText(GetResString(IDS_SS_PREPARING));
		else if (thePrefs.IsDSSEnabled() && theApp.BC->IsPingWorking())
			GetDlgItem(IDC_DSS_STATUS)->SetWindowText(GetResString(IDS_SS_SUCCESFULL));
		else if (thePrefs.IsDSSEnabled() && withSSStats)
			GetDlgItem(IDC_DSS_STATUS)->SetWindowText(GetResString(IDS_SS_FAILED));
		else if (withSSStats || !thePrefs.IsDSSEnabled())
			GetDlgItem(IDC_DSS_STATUS)->SetWindowText(GetResString(IDS_SS_DISABLED));

		if (thePrefs.IsZZRatio() || thePrefs.IsIncludeTCPAck() || (thePrefs.IsConnectionsOverHead() && !thePrefs.IsManageConnection())){
			GetDlgItem(IDC_MINDOWN_VAL)->SetWindowText(GetResString(IDS_SS_SESSION));
			CString buffer;
			if (thePrefs.IsDSSEnabled() && (theApp.BC->IsPingWorking() || theApp.BC->IsPingPreparing())){
				if (thePrefs.IsAutoMaxDownload())
					GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(GetResString(IDS_SS_AUTOLIMIT));
				else{
					CString buffer;
					buffer.Format(_T("%.1f"),thePrefs.GetMaxBCDownload());
					GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(buffer);
				}
			}
			else{
				if (thePrefs.GetMaxDownload() == UNLIMITED)
					GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(GetResString(IDS_SS_UNLIMITED));
				else{
					CString buffer;
					buffer.Format(_T("%.1f"),thePrefs.GetMaxDownload());
					GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(buffer);
				}
			}
		}
		else if (thePrefs.IsUSSEnabled() && ((theApp.BC->IsPingWorking() || theApp.BC->IsPingPreparing()))){
				CString buffer;
				if (thePrefs.IsDSSEnabled() && (theApp.BC->IsPingWorking() || theApp.BC->IsPingPreparing())){
					float download=theApp.BC->GetMaxDownloadOnUpload(thePrefs.GetMinBCUpload(), thePrefs.GetMinBCDownload(), (float)(thePrefs.IsConnectionsOverHead() && thePrefs.IsManageConnection()));
					buffer.Format(_T("%.1f"),download);
					GetDlgItem(IDC_MINDOWN_VAL)->SetWindowText(buffer);
					if (thePrefs.IsAutoMaxUpload())
						GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(GetResString(IDS_SS_AUTOLIMIT));
					else {
						if (thePrefs.IsAutoMaxDownload()){
							download = theApp.BC->GetMaxDownloadOnUpload(thePrefs.GetMaxBCUpload(), thePrefs.GetMinBCDownload(), (float)(thePrefs.IsConnectionsOverHead() && thePrefs.IsManageConnection()));
							if (download < thePrefs.GetMinBCDownload()){
								buffer.Format(_T("%.1f"),download);
								GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(buffer);
							}
							else
								GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(GetResString(IDS_SS_AUTOLIMIT));
						}
						else {
							download = theApp.BC->GetMaxDownloadOnUpload(thePrefs.GetMaxBCUpload(), thePrefs.GetMaxBCDownload(), (float)(thePrefs.IsConnectionsOverHead() && thePrefs.IsManageConnection()));
							buffer.Format(_T("%.1f"),download);
							GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(buffer);
						}
					}
				}
				else{
					float download=theApp.BC->GetMaxDownloadOnUpload(thePrefs.GetMinBCUpload(), thePrefs.GetMaxDownload(), (float)(thePrefs.IsConnectionsOverHead() && thePrefs.IsManageConnection()));
					if (download == UNLIMITED)
						GetDlgItem(IDC_MINDOWN_VAL)->SetWindowText(GetResString(IDS_SS_UNLIMITED));
					else {
						buffer.Format(_T("%.1f"),download);
						GetDlgItem(IDC_MINDOWN_VAL)->SetWindowText(buffer);
					}
					if (thePrefs.IsAutoMaxUpload()){
						if (download == UNLIMITED)
							GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(GetResString(IDS_SS_UNLIMITED));
						else
							GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(GetResString(IDS_SS_AUTOLIMIT));
					}
					else {
						download = theApp.BC->GetMaxDownloadOnUpload(thePrefs.GetMaxBCUpload(), thePrefs.GetMaxDownload(), (float)(thePrefs.IsConnectionsOverHead() && thePrefs.IsManageConnection()));
						if (download == UNLIMITED)
							GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(GetResString(IDS_SS_UNLIMITED));
						else {
							buffer.Format(_T("%.1f"),download);
							GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(buffer);
						}
					}
				}
		}
		else {
				CString buffer;
				if (thePrefs.IsDSSEnabled() && (theApp.BC->IsPingWorking() || theApp.BC->IsPingPreparing())){
					float download=theApp.BC->GetMaxDownloadOnUpload(thePrefs.GetMaxUpload(), thePrefs.GetMinBCDownload(), (float)(thePrefs.IsConnectionsOverHead() && thePrefs.IsManageConnection()));
					buffer.Format(_T("%.1f"),download);
					GetDlgItem(IDC_MINDOWN_VAL)->SetWindowText(buffer);
					if (thePrefs.IsAutoMaxDownload()){
						if (download < thePrefs.GetMinBCDownload()){
							buffer.Format(_T("%.1f"),download);
							GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(buffer);
						}
						else
							GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(GetResString(IDS_SS_AUTOLIMIT));
					}
					else {
						download = theApp.BC->GetMaxDownloadOnUpload(thePrefs.GetMaxUpload(), thePrefs.GetMaxBCDownload(), (float)(thePrefs.IsConnectionsOverHead() && thePrefs.IsManageConnection()));
						buffer.Format(_T("%.1f"),download);
						GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(buffer);
					}
				}
				else {
					float download=theApp.BC->GetMaxDownloadOnUpload(thePrefs.GetMaxUpload(), thePrefs.GetMaxDownload(), (float)(thePrefs.IsConnectionsOverHead() && thePrefs.IsManageConnection()));
					if (download == UNLIMITED){
						GetDlgItem(IDC_MINDOWN_VAL)->SetWindowText(GetResString(IDS_SS_UNLIMITED));
						GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(GetResString(IDS_SS_UNLIMITED));
					}
					else {
						buffer.Format(_T("%.1f"),download);
						GetDlgItem(IDC_MINDOWN_VAL)->SetWindowText(buffer);
						GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(buffer);
					}
				}
		}
		if (thePrefs.IsUSSEnabled() || thePrefs.IsDSSEnabled())
			GetDlgItem(IDC_PINGING_VAL)->SetWindowText(theApp.BC->GetPingedServer());
		else
			GetDlgItem(IDC_PINGING_VAL)->SetWindowText(_T("-"));
	}
}
